%global gittag 120a9fce218dd5cfc144df8a2e363736514a2bfe
Name:          transactions-essentials
Version:       4.0.4
Release:       1%{?dist}
Summary:       Open Source JTA/XA
License:       ASL 2.0
URL:           https://www.atomikos.com/Main/TransactionsEssentials
Source0:       https://github.com/atomikos/transactions-essentials/archive/%{gittag}/%{name}-%{version}.tar.gz
Source1:       https://www.atomikos.com/downloads/licenses/apache-license-2.0.txt

BuildRequires: maven-local
BuildRequires: mvn(com.h2database:h2)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(javax.ws.rs:javax.ws.rs-api)
BuildRequires: mvn(jdepend:jdepend)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(log4j:log4j:1.2.17)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jms_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jta_1.1_spec)
BuildRequires: mvn(org.apache.logging.log4j:log4j-core)
BuildRequires: mvn(org.aspectj:aspectjrt)
BuildRequires: mvn(org.aspectj:aspectjweaver)
BuildRequires: mvn(org.eclipse.persistence:eclipselink)
BuildRequires: mvn(org.eclipse.persistence:javax.persistence)
BuildRequires: mvn(org.hibernate:hibernate-core:3)
%if %{?fedora} > 24
BuildRequires: mvn(org.hibernate:hibernate-entitymanager:4)
%else
BuildRequires: mvn(org.hibernate:hibernate-entitymanager)
%endif
BuildRequires: mvn(org.mockito:mockito-all)
BuildRequires: mvn(org.osgi:org.osgi.core)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-simple)
BuildRequires: mvn(org.springframework:spring-aop)
BuildRequires: mvn(org.springframework:spring-context)
BuildRequires: mvn(org.springframework:spring-orm)
BuildRequires: mvn(org.springframework:spring-test)
BuildRequires: mvn(org.springframework:spring-tx)
BuildRequires: mvn(org.springframework.data:spring-data-jpa)

# transactions-tcc-rest
# BuildRequires: mvn(ch.qos.logback:logback-classic)
# BuildRequires: mvn(com.fasterxml.jackson.jaxrs:jackson-jaxrs-json-provider)
# BuildRequires: mvn(org.apache.cxf:cxf-rt-frontend-jaxrs)
# BuildRequires: mvn(org.apache.cxf:cxf-rt-rs-client)
# BuildRequires: mvn(org.apache.cxf:cxf-rt-rs-extension-providers)
# BuildRequires: mvn(org.apache.cxf:cxf-rt-transports-http-jetty)
# BuildRequires: mvn(org.codehaus.jettison:jettison)
# BuildRequires: mvn(org.codehaus.mojo:exec-maven-plugin)

BuildArch:     noarch

%description
TransactionsEssentials is our open source transaction management
with JTA/XA and connection pooling for self-contained applications
outside of the application server, ideal for your cloud.
TransactionsEssentials is free - but unsupported.

%package api
Summary:       Transactions API

%description api
Transactions API.

%package ate
Summary:       Atomikos Transactions Essentials POM

%description ate
Atomikos Transactions Essentials POM.

%package atomikos-parent
Summary:       Atomikos All POM

%description atomikos-parent
Reliability through Atomicity: manage your distributed transactions and
protect your mission critical data.

%package atomikos-util
Summary:       Atomikos Util

%description atomikos-util
Atomikos Util.

%package eclipselink
Summary:       Transactions Eclipselink

%description eclipselink
Transactions Eclipselink.

%package hibernate3
Summary:       Transactions Hibernate3

%description hibernate3
Transactions Hibernate3.

%package hibernate4
Summary:       Transactions Hibernate4

%description hibernate4
Transactions Hibernate4.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%package jdbc
Summary:       Transactions JDBC

%description jdbc
Transactions JDBC.

%package jms
Summary:       Transactions JMS

%description jms
Transactions JMS.

%package jndi-provider
Summary:       Transactions JNDI provider

%description jndi-provider
Transactions JNDI provider.

%package jta
Summary:       Transactions JTA

%description jta
Transactions JTA.

%package osgi
Summary:       Transactions OSGi

%description osgi
Transactions OSGi.

%package tcc-rest-api
Summary:       Transactions / TCC REST API

%description tcc-rest-api
Transactions / TCC REST API.

%prep
%setup -q -n %{name}-%{gittag}

cp -p %SOURCE1 .

%pom_remove_plugin -r :maven-clover2-plugin

%pom_remove_plugin :maven-source-plugin
%pom_remove_plugin :maven-source-plugin public
%pom_remove_plugin :maven-license-plugin public
%pom_remove_plugin -r :maven-release-plugin
%pom_remove_plugin -r :maven-javadoc-plugin

# org.apache.maven.wagon:wagon-ftp:1.0-beta-6
%pom_xpath_remove "pom:build/pom:extensions"

%pom_disable_module transactions-hibernate2 public
%pom_disable_module transactions-tcc-rest public

%pom_change_dep org.hibernate: :hibernate-core:3 public/transactions-hibernate3
%if %{?fedora} > 24
%pom_change_dep org.hibernate: ::4 public/transactions-hibernate4
%endif
%pom_change_dep :servlet-api javax.servlet:javax.servlet-api:3.1.0 public/util
for p in eclipselink \
  hibernate3 \
  hibernate4 \
  jms \
  jndi-provider \
  jta \
  osgi
 do
 %pom_change_dep -r :geronimo-jta_1.0.1B_spec :geronimo-jta_1.1_spec public/transactions-${p}
done

sed -i '/Embed-Dependency/d' public/transactions-osgi/osgi.bnd
%pom_xpath_set "pom:dependency[pom:groupId= 'com.atomikos']/pom:optional" false public/transactions-osgi
%pom_xpath_remove "pom:dependency/pom:scope" public/transactions-osgi

for p in transactions \
  transactions-api \
  transactions-eclipselink \
  transactions-hibernate3 \
  transactions-hibernate4 \
  transactions-jdbc \
  transactions-jms \
  transactions-jndi-provider \
  transactions-jta \
  transactions-tcc-rest-api \
  util
 do
 %pom_add_plugin org.apache.felix:maven-bundle-plugin public/${p} "
   <executions>
      <execution>
         <id>bundle-manifest</id>
         <phase>compile</phase>
         <goals>
            <goal>manifest</goal>
         </goals>
      </execution>
   </executions>"
 %pom_add_plugin org.apache.maven.plugins:maven-jar-plugin public/${p} "
   <configuration>
      <archive>
         <manifestFile>\${project.build.outputDirectory}/META-INF/MANIFEST.MF</manifestFile>
      </archive>
   </configuration>"
done

# Use old slf4j release
rm -r public/util/src/test/java

%build

%mvn_build -s -- -Popensource

%install
%mvn_install

%files -f .mfiles-transactions
%files api -f .mfiles-transactions-api
%doc README.md
%license LICENSE.txt apache-license-2.0.txt

%files ate -f .mfiles-ate
%license LICENSE.txt apache-license-2.0.txt

%files atomikos-parent -f .mfiles-atomikos-parent
%license LICENSE.txt apache-license-2.0.txt

%files atomikos-util -f .mfiles-atomikos-util

%files eclipselink -f .mfiles-transactions-eclipselink
%files hibernate3 -f .mfiles-transactions-hibernate3
%files hibernate4 -f .mfiles-transactions-hibernate4
%files javadoc -f .mfiles-javadoc
%license LICENSE.txt apache-license-2.0.txt

%files jdbc -f .mfiles-transactions-jdbc
%files jms -f .mfiles-transactions-jms
%files jndi-provider -f .mfiles-transactions-jndi-provider
%files jta -f .mfiles-transactions-jta
%files osgi -f .mfiles-transactions-osgi
%license LICENSE.txt apache-license-2.0.txt

%files tcc-rest-api -f .mfiles-transactions-tcc-rest-api
%license LICENSE.txt apache-license-2.0.txt

%changelog
* Tue Oct 18 2016 gil cattaneo <puntogil@libero.it> 4.0.4-1
- initial rpm

